; TIP1026.LSP: BLKBRK.LSP   Break Lines at Block   (c)1994, Rick E. France

(defun dtr (D) (* pi (/ D 180.0)))

(defun C:BLKBRK ( / BLG CMD CNT CPT1 CPT2 EGI EGT ELS EN ET
      HI INT IPT PASS PT1 PT2 PTA SEN SF SS SSL
   )
   (setq CMD (getvar "cmdecho") HI (getvar "highlight"))
   (setvar "cmdecho" 0)   (setvar "highlight" 0)
   (setq ELS (entlast) EGT (entget ELS) IPT (cdr (assoc 10 EGT))
      SF (cdr (assoc 41 EGT)) BLG (/ SF 2 (cos (dtr 45)))
      CPT1 (polar IPT (dtr 225) BLG) CPT2 (polar IPT (dtr 45) BLG)
      SS (ssdel ELS (ssget "c" CPT1 CPT2)) CNT 0 SSL (sslength SS)
   )
   (while (< CNT SSL)
      (setq EGI (entget (setq EN (ssname SS CNT))) ET (cdr (assoc 0 EGI)))
      (cond ((= ET "LINE")
            (setq PTA (angle (cdr (assoc 10 EGI)) (cdr (assoc 11 EGI))))
         )
         ((= ET "POLYLINE")
            (setq SEN (entnext EN))
            (while (not INT)
               (setq PT1 (cdr (assoc 10 (entget SEN)))
                  SEN (entnext SEN) PT2 (cdr (assoc 10 (entget SEN)))
                  INT (inters PT1 PT2 CPT1 CPT2)
            )  )
            (setq PTA (angle PT1 PT2) INT nil)
         )
         (t (cond ((= ET "INSERT")   (setq ET "a block"))
               ((= ET "ARC")      (setq ET "an arc"))
               ((= ET "TEXT")     (setq ET "text"))
               (t       (setq ET (strcat "a " (strcase ET t))))
            )
            (setq PASS t)
            (prompt (strcat "\n*Invalid selection*   Can't break " ET))
      )     )
      (if (not PASS)
         (progn (setq PT1 (polar IPT PTA (/ SF 2)) PT2 (polar PT1 (+ pi PTA) SF))
            (command "break" EN PT1 PT2)
      )  )
      (setq CNT (1+ CNT) PASS nil)
   )
   (setvar "cmdecho" CMD)   (setvar "highlight" HI)
(princ)); end blkbrk.lsp
