; TIP1027.LSP: DDETACH.LSP    Detach Xrefs   (c)1994, Michael Jenkins

(defun C:DDETACH (/ _ACCEPT _GETXREFS ID XREFLIST RETURN COUNTER STRING)
   (defun _getxrefs (/ XREFS BLK)
      (setq 
         XREFS '()
         BLK (tblnext "BLOCK" 'T)
      )
      (while BLK
         (if (= (LOGAND (cdr (assoc 70 BLK)) 4) 4)
            (setq XREFS (append XREFS (list (cdr (assoc 2 BLK)))))
         )
         (setq BLK (tblnext "BLOCK"))   
      )
      (if (> (LENGTH XREFS) 0)
         XREFS
         nil
      )   
   )
   (defun _accept ()
      (if (= (setq RETURN (get_tile "xrefs")) "")
         (set_tile "error" "Empty or invalid input")
         (done_dialog 1)
      )
   )
   (if (_getxrefs)
      (progn
         ;set up the dialog identification
         (setq ID (load_dialog "ddetach"))
         ;open dialog
         (new_dialog "ddetach" ID)
         (start_list "xrefs")
         (foreach N (setq XREFLIST (_getxrefs)) (add_list N))
         (end_list)
         (action_tile "accept" "(_accept)")
         (if (= (start_dialog) 1)
            (progn
               (setq
                  COUNTER 1
                  STRING ""
                  RETURN (strcat return " ")
               )
               (while
                  (/= COUNTER
                     (1+
                        (strlen RETURN)
                     )
                  )
                  (if (/= (substr RETURN COUNTER 1) " ")
                     (setq STRING (strcat STRING (substr RETURN COUNTER 1)))
                     (progn
                        (command "_.xref" "detach" (nth (atoi STRING) xreflist))
                        (setq string "")
                     )
                  )
                  (setq COUNTER (1+ COUNTER))
               )
            )
         )            
         (unload_dialog id)
      )
      (prompt "\nNo XREFs found.")
   )
   (princ)
)
(princ "DDETACH loaded.")
(princ); end ddetach.lsp

