// SWDU8.DCL V12.0
// Drawing Setup dialog box
// Copyright (c) Barry R. Bowen 1994
// 3394 Coleman Rd., Memphis, TN 38128

swdu8 : dialog {
 label = "Drawing Title Sheet Setup";
   : row {
    : popup_list { label = " Units:"; key = "units";
      width = 25; fixed_width=true; popup_height = 3; }
    : popup_list { label= " Precision:"; key = "prec";
      width = 28; fixed_width=true; popup_height = 3; }
  }//row
  spacer;
  : row {
    : popup_list { label= "Scales:"; key = "scales";
      width = 25; fixed_width=true; popup_height = 3; }
    : popup_list { label= "Sheet Size:"; key = "shtsz";
      width = 28; fixed_width=true; popup_height = 3; }
   }//row
  spacer;
    : popup_list { label= "Title Sheet:"; key = "titlsh";
      popup_height = 3; }
  spacer;
  : boxed_row {
    label = "Modes";
    : toggle { label = "Ortho"; key = "orth"; }
    : toggle { label = "Snap";  key = "snap"; }
    : toggle { label = "Grid";  key = "grd";  }
    : toggle { label = "Blips"; key = "blip"; }
    : toggle { label = "Highlight"; key = "highl"; }
  }//row
  spacer;
  : row {
    : edit_box { label = "LTscale:";  key = "ltscl";
      width = 5; fixed_width=true; }
    : edit_box { label = "DIMscale:"; key = "dimscl";
      width = 5; fixed_width=true; }
    : popup_list { label= "Snap:";    key = "snpsz";
      width = 5; fixed_width=true; popup_height = 3; }
    : popup_list { label= "Grid:";    key = "grdsz";
      width = 5; fixed_width=true; popup_height = 3; }
  }//row
  spacer;
  : boxed_row { label = "Setup Options";
    : toggle { label = "Paper Space";    key = "papsp"; }
    : toggle { label = "Insert As Xref"; key = "xref";  }
    : toggle { label = "Insert Title";   key = "intitl";}
    : toggle { label = "Basic Border";   key = "basic"; }
  }//boxed row
  spacer_1; ok_cancel_help; errtile;
}

