; TIP1032.LSP: PURGE.LSP    Automated Purge   (c)1994, Rick E. France 

(command ".undefine" "purge")
(defun C:PURGE ( / CMD CNT PTYPE)
   (setq CMD (getvar "cmdecho"))
   (setvar "cmdecho" 0)
   (initget "Yes No")
   (setq PTYPE (getkword "\nGlobal purge of all unreferenced objects? <Yes>: "))
   (if (= PTYPE "No")
      (command ".purge")
      (progn (setq CNT (+ (purge "block") (purge "dimstyle") (purge "ltype")
               (purge "style") (purge "layer")
         )          )
         (command ".purge" "a")
         (repeat CNT (command "y"))
   )  )
   (setvar "cmdecho" CMD)
(princ))

(defun PURGE ( GRP / CHK CNT INF STDOBJ SYM)
   (setq INF (tblnext GRP t) CNT 0 STDOBJ '("CONTINUOUS" "STANDARD" "0"))
   (while INF
      (setq CHK (cdr (assoc 70 INF)) SYM (cdr (assoc 2 INF)))
      (if (and (< CHK 48) (not (member SYM STDOBJ)))   (setq CNT (1+ CNT)))
      (setq INF (tblnext GRP))
   ) CNT
); end purge.lsp
