; TIP1033.LSP: FENCE.LSP    Fence in Plan View   (c)1994, Denis Cossette

; Draw sections of wire fence symbols

(PRINC "\nLoading FENCE.LSP  Wait...")
(defun WF_FENCE (/ Cpt PCpt SPt NXTpt Dt ANG Drem CLOSE E1 OER ANS TEST
VLIST UO LISTUOt LISTUO CLOSE2 sn SP)
;wf:rad and wf:distx permanent variables
  (graphscr)
  (setq LISTUOt '() sn 0)
;********WF_ERR
      (defun WF_ERR (msg)
        (if (/= msg "Function cancelled")
            (princ  (strcat "\nError: " msg)))
        (setq msg nil)
        (command "UNDO" "AUTO" "ON")
        (WF_RSV)
        (if WF_ERR
           (setq *error* OER))
        (grtext)
        (princ)
      )
  (grtext 39 " FENCE ")(grtext 40 "* * * *")(grtext 42 "Apr. 92")
  (grtext 43 "   k7  ")
  (WF_LSV '("orthomode" "cmdecho" "blipmode" "snapmode"))
  (if *error*
     (setq OER *error* *error* WF_ERR)
     (setq *error* WF_ERR)
  )
  (setvar "cmdecho" 0)(setvar "orthomode" 0)
  (setvar "snapmode" 0)
  (setq SP (getpoint "\nFENCE Start point  :"))
  (setq Cpt SP)
  (WF_ADDLIST UO SP)
  (if (null wf:rad)
     (progn
        (prompt "\nX Radius           :")
        (command "circle" SP pause)
        (setq E1 (entget(entlast)))
        (setq wf:rad (cdr (assoc 40 e1))) (entdel (entlast))
     )
  )
  (setq SPt T
        TEST T
        CLOSE T
        ANS T
        CLOSE2 T
  )
  (if (null wf:distx)
     (while ANS
      (setq wf:distx (getdist SP "\nDistance between X :"))
         (if (< wf:distx (* wf:rad 2.0))
           (prompt "\n Warning! Distance shorter than Xradius !")
           (setq ANS nil)
         )
     )
  )
  (command "UNDO" "AUTO" "OFF")
  (while TEST
   (initget "Newstartpt Distance Radius Close Undo Quit")
   (setq NXTpt
(getpoint Cpt
"\nNewstartpt/Distance/Radius(X)/Close/Undo/Quit <Next point> :"))
   (cond
      ((= NXTpt "Newstartpt")  (setq SP (getpoint "\nNew start point :"))
                         (setq Cpt SP SPt T UO nil LISTUOt '())
                         (WF_ADDLIST UO SP)
      )
      ((= NXTpt "Radius")
       (setq ANS T)
       (while ANS
 (prompt (strcat "\n" "Radius <" (rtos wf:rad) ">  New radius : "))
         (command "circle" Cpt pause)
         (setq E1 (entget(entlast)))
         (setq wf:rad (cdr (assoc 40 e1))) (entdel (entlast))
         (if (< wf:distx (* wf:rad 2.0))
           (prompt "\n Warning !  Distance shorter than radius.")
           (setq ANS nil)
         )
       )
      )
      ((= NXTpt "Distance") (setq ANS T)
                         (while ANS
                           (setq wf:distx (getdist Cpt "\nDistance between X :"))
                           (if (< wf:distx (* wf:rad 2.0))
              (prompt "\n Warning !  Distance shorter than radius.")
                               (setq ANS nil)
                            )
                         )
      )
      ((= NXTpt "Close")   (if (and (caar LISTUO) CLOSE2)
                            (progn
                               (setq CLOSE nil
                                  ANG (angle Cpt SP)
                                  Dt  (distance Cpt SP)
                                  PCpt Cpt
                                  Cpt  (polar Cpt ANG wf:distx)
                                  NXTpt SP
                                  Drem Dt
                              )
                              (WF_DRAWFENCE)
                            )
                            (prompt "\nCannot close !")
                         )
                         (setq CLOSE2 nil)
      )
      ((= NXTpt "Quit" ) (setq TEST nil))
      ((= NXTpt "Undo")     (setq UO (caar LISTUO))
                         (if  UO  (progn (command "UNDO" UO)
                                         (setq LISTUO (cdr LISTUO))
                                         (setq Cpt (cadar LISTUO))
                                         (setq sn (abs(- 1 sn)))
                                         (setq LISTUOt (reverse LISTUO))
                                         (if (= (caar LISTUO) nil)
                                             (setq SPt T)
                                         )
                                         (setq CLOSE2 T)
                                  )
                                  (progn
                                     (prompt"\nNothing to Undo !")
                                     (setq SPt T)
                                     (setq Cpt (cadar LISTUO))
                                  )
                         )
      )
      ((null NXTpt)(prompt "\nYou must enter a point to continue or keyword!"))
      (T                 (setvar "blipmode" 0)
                         (if (= SPt T)
                               (setq ANG (angle SP NXTpt)
                                     Dt  (distance SP NXTpt)
                                     Cpt SP
                               )
                               (setq ANG (angle Cpt NXTpt)
                                     Dt  (distance Cpt NXTpt)
                                     TURNpt Cpt
                                     PCpt Cpt
                                     Cpt  (polar Cpt ANG wf:distx)
                               )
                         )
                         (setq Drem Dt)
                         (WF_DRAWFENCE)
      )
   )
  )
  (command "UNDO" "AUTO" "ON")
  (grtext)
  (WF_RSV)
  (if WF_ERR
  (setq *error* OER))
  (princ (strcat "\n "(itoa sn)" drawn section<s>."))
  (princ)
)

(defun WF_DRAWFENCE ()
   (setq UO 0)
   (if (= SPt T)
      (progn
        (WF_DRAWX)
        (setq PCpt SP
              Cpt (polar SP ANG wf:distx)
        )
      )
   )
   (while Drem
      (if (> Drem (* wf:distx 1.25))
         (progn   (WF_DRAWLINE)
                  (WF_DRAWX)
                  (setq PCpt Cpt
                        Cpt (polar Cpt ANG wf:distx)
                        Drem (- Drem wf:distx)
                  )
          )
          (progn   (setq Cpt NXTpt TURNpt Cpt)
                   (WF_DRAWLINE)
                   (if (= CLOSE T)
                       (WF_DRAWX)
                   )
                   (setq Drem nil
                         CLOSE T
                         CLOSE2 T
                   )
          )
       )
   )
   (WF_ADDLIST UO TURNpt)
   (setq SPt nil sn (+ 1 sn))
)

(defun WF_DRAWLINE ()
   (setq P5 (polar PCpt ANG wf:rad)
         P6 (polar Cpt (+ ANG pi) wf:rad)
   )
   (command "pline" P5 P6 "")
   (setq UO (+ 1 UO))
)
(defun WF_DRAWX ()
   (setq P1 (polar Cpt (+ ANG (/ pi 4.0)) wf:rad)
         P2 (polar Cpt (+ ANG (* (/ pi 4.0) 3)) wf:rad)
         P3 (polar Cpt (+ ANG (* (/ pi 4.0) 5)) wf:rad)
         P4 (polar Cpt (+ ANG (* (/ pi 4.0) 7)) wf:rad)
   )
   (command "LINE" P1 P3 "")
   (command "LINE" P2 P4 "")
   (setq UO (+ 2 UO))
; Other possibilities
;to draw donut instead 'X'
;  (command "DONUT" "0" (* wf_ray 2.0) Cpt "")
;to draw Text (letter E) instead 'X'
;  (command "TEXT" "M" Cpt "" "" "E")
;Modify Undo count
;  (setq UO (+ 1 UO))
)

(defun WF_ADDLIST (UO Cpt)
   (setq LISTUOt (append LISTUOt (list(list UO Cpt))))
   (setq LISTUO (reverse LISTUOt))
)

(defun WF_LSV (v)
   (setq VLIST '())
   (while v
      (setq VLIST (append VLIST(list(list(car v)(getvar (car v))))))
      (setq v (cdr v))
   )
)

(defun WF_RSV ()
   (while VLIST (setvar (caar VLIST)(cadar VLIST))
                 (setq VLIST (cdr VLIST))
   )
)
(defun C:FENCE () (WF_FENCE))
(princ "loaded !")
(princ)

